#ifndef __MEMORY_H__
#define __MEMORY_H__

#include "board.h"

/* Kernel stack addresses. */

#define STAGE2_INIT_STACK	0x80004000
#define STAGE2_EXCEPTION_STACK	0x80008000

/* Page table details accessed in kernel mode. */

#define STAGE2_PAGE_TABLE_TOP	0x81800000
#define STAGE2_PAGE_TABLE_BASE	0x81400000

/* Page table virtual address limit. */

#define STAGE2_VIRTUAL_TOP	0x08000000

/* Page table computed task structure size. */

#define STAGE2_PAGE_TABLE_TASK	(STAGE2_VIRTUAL_TOP / (2 * STAGE2_PAGESIZE))

/* User mode and physical addresses. */

#define TASK_GPIO_BASE		(STAGE2_VIRTUAL_TOP - GPIO_REGION_SIZE)
#define TASK_STACK_TOP		TASK_GPIO_BASE
#define TASK_STACK_PHYSICAL	0x01c00000
#define TASK_STACK_SIZE		0x00002000

/* Common configuration. */

#define STAGE2_PAGESIZE		(4 * 1024)

#endif /* __MEMORY_H__ */
